#include <windows.h>
#include <math.h>
#include "xvec.h"

#define					W					640
#define					H					480

char					g_szWindowName[]	= "ray";
char					g_szWindowClass[]	= "ray32";
HWND					g_hWnd;
HINSTANCE				g_hInst;

BITMAPINFO				g_bi;
u32 *					p_dib;

void dib_blit( HDC hdc )
{
	SetDIBitsToDevice( hdc, 0, 0, W, H, 0, 0, 0, H, p_dib, &g_bi, DIB_RGB_COLORS );
}

LRESULT CALLBACK wnd_proc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	switch ( uMsg ) {
		case WM_NCHITTEST: return HTCAPTION;

		case WM_PAINT: {
			PAINTSTRUCT	ps;
			BeginPaint( hWnd, &ps );
			dib_blit( ps.hdc );
			EndPaint( hWnd, &ps );
		} return 0;

		case WM_KEYDOWN: if ( (int)wParam != VK_ESCAPE ) break;
		case WM_DESTROY:
			PostQuitMessage( 0 );
			return 0;
	}
	return DefWindowProc( hWnd, uMsg, wParam, lParam );
}

void update_proc()
{
	dib_blit( GetDC( g_hWnd ) );
}

int APIENTRY WinMain( HINSTANCE hInst, HINSTANCE hPInst, LPSTR lpCmdLine, int nCmdShow )
{
	MSG			msg;
	WNDCLASS	wc;

	g_hInst = hInst;

	ZeroMemory( &g_bi, sizeof( BITMAPINFO ) );
	g_bi.bmiHeader.biSize			= sizeof( BITMAPINFOHEADER );
	g_bi.bmiHeader.biWidth			= W;
	g_bi.bmiHeader.biHeight			= -H;
	g_bi.bmiHeader.biPlanes			= 1;
	g_bi.bmiHeader.biBitCount		= 32;
	g_bi.bmiHeader.biCompression	= BI_RGB;
	p_dib = new u32 [W * H];

	ZeroMemory( &wc, sizeof( WNDCLASS ) );
	wc.style			= CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc		= wnd_proc;
	wc.hInstance		= g_hInst;
	wc.hCursor			= LoadCursor( g_hInst, IDC_ARROW );
	wc.hbrBackground	= (HBRUSH)GetStockObject( BLACK_BRUSH );
	wc.lpszClassName	= g_szWindowClass;
	RegisterClass( &wc );

	g_hWnd = CreateWindowEx( WS_EX_TOPMOST,
		g_szWindowClass, g_szWindowName, WS_POPUP | WS_VISIBLE,
		(GetSystemMetrics( SM_CXSCREEN ) >> 1) - (W >> 1),
		(GetSystemMetrics( SM_CYSCREEN ) >> 1) - (H >> 1),
		W, H, NULL, NULL, g_hInst, NULL );

	xtracer_render( W, H, p_dib, update_proc );

	while ( GetMessage( &msg, NULL, 0, 0 ) ) {
		TranslateMessage( &msg );
		DispatchMessage( &msg );
	}

	DestroyWindow( g_hWnd );
	UnregisterClass( g_szWindowClass, g_hInst );
	delete [] p_dib;

	return 0;
}
